﻿@using Jb.Framework.Common.Forms
@using Jb.Framework.Common.Forms.Validation
@using Jumbula.Common.Helper
@model JbNumber

@{

    var numberHtmlAttr = new Dictionary<string, object>();
    var cssClasses = new List<string>();

    var width = "element_width-third";
    switch (Model.Width)
    {
        case ElementWidth.Half:
            {
                width = "element_width-half";
            }
            break;
        case ElementWidth.Full:
            {
                width = "element_width-full";
            }
            break;
    }

    cssClasses.Add(Model.Size.ToDescription());
    cssClasses.Add("form-control");
    InputHelper.InputAccessible(Model, (VisibilityMode)ViewBag.VisibleMode, ref numberHtmlAttr);

    if (cssClasses.Any())
    {
        numberHtmlAttr.Add("class", string.Join(" ", cssClasses));
    }

    numberHtmlAttr.Add("Type", "text");
    numberHtmlAttr.Add("placeholder", Model.PlaceHolder);
    numberHtmlAttr.Add("data-val", "true");
    numberHtmlAttr.Add("data-val-number", "Value Must Be Number");
    if (Model.CurrentMode != AccessMode.Design)
    {
        if (Model.Validations.Any(x => x.Type == ElementValidationType.Required))
        {
            numberHtmlAttr.Add("data-val-Required", Model.Validations.First(x => x.Type == ElementValidationType.Required).Message);
        }
        if (Model.MinVal.HasValue || Model.MaxVal.HasValue)
        {
            //var rangevalidation = Model.Validations.Single(x => x.Type == ElementValidationType.Range) as ElementRangeValidation;
            numberHtmlAttr.Add("data-val-range-min", Model.MinVal);
            numberHtmlAttr.Add("data-val-range-max", Model.MaxVal);
            numberHtmlAttr.Add("data-val-range", Model.InvalidRangeMessage);
        }

        if (Model.CurrentMode == AccessMode.ReadOnly)
        {
            numberHtmlAttr.Add("ReadOnly", true);
        }
    }

}

<div class="form-group JbFormControll JbNumber @width" style="display: @(Model.VisibleMode != VisibilityMode.Both && Model.VisibleMode != (VisibilityMode)ViewBag.VisibleMode ? "none" : "block")">
    @for (var i = 0; i < Model.Validations.Count; i++)
    {
        //Custom model binder require full model name , i add Validations[i] at the end of string that mvc generate
        var hiddnModelBindername = "Validations[" + i + "].QVModelType";
        @Html.Hidden(hiddnModelBindername, Model.Validations[i].GetType())


        @Html.HiddenFor(x => x.Validations[i].IsChecked)
        @Html.HiddenFor(x => x.Validations[i].Type)
        @Html.HiddenFor(x => x.Validations[i].Message)

    }
    @Html.GenerateHiddenFields(Model)

    @foreach (var accRole in Model.AccessRole)
    {
        @Html.HiddenFor(modelItem => accRole)
    }

    @Html.LabelFor(m => m.Title, Model.Title, new { @class = (Model.Validations.Any(t => t.Type == ElementValidationType.Required) || Model.IsRequired) ? "req" : "" })
    @if (!string.IsNullOrEmpty(Model.HelpText))
    {
        <a href="#" class="help" role="button" data-toggle="popover" data-trigger="focus" data-content="@Model.HelpText"></a>
    }
    @Html.TextBoxFor(model => model.Value, htmlAttributes: numberHtmlAttr)
    @Html.ValidationMessageFor(model => model.Value)
</div>



